package com.ejie.ab79.control;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasProtocolo;
import com.ejie.ab79.model.preguntasRespuestas.RelProPre;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.protocolos.Protocolos;
import com.ejie.ab79.service.preguntasRespuestas.PreguntasProtocoloService;
import com.ejie.ab79.service.protocolos.ProtocolosService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProtocolosController  
 * 
 *  
 */

@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/protocolos")

public class ProtocolosController {

	private static final Logger logger = LoggerFactory.getLogger(ProtocolosController.class);

	@Autowired
	private ProtocolosService protocolosService;

	@Autowired
	private PreguntasProtocoloService preguntasProtocoloService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idProtocolo
	 *            Integer
	 * @return Protocolos Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idProtocolo}", method = RequestMethod.GET)
	public @ResponseBody Protocolos get(@PathVariable Integer idProtocolo) {
		Protocolos protocolos = new Protocolos();
		protocolos.setIdProtocolo(idProtocolo);
		protocolos = this.protocolosService.find(protocolos);
		ProtocolosController.logger.info("[GET - findBy_PK] : Obtener Protocolos por PK");
		return protocolos;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterProtocolos
	 *            Protocolos Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Protocolos> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Protocolos> getAll(@ModelAttribute Protocolos filterProtocolos) {
		ProtocolosController.logger.info("[GET - find_ALL] : Obtener Protocolos por filtro");
		return this.protocolosService.findAll(filterProtocolos, null);
	}

	@RequestMapping(value = "/validados", method = RequestMethod.GET)
	public @ResponseBody List<Protocolos> getAllValidados(@ModelAttribute Protocolos filterProtocolos,
			@RequestParam(value = "direccion.idDireccion", required = false) Integer idDireccion) {
		ProtocolosController.logger.info("[GET - find_ALL] : Obtener Protocolos por filtro");
		filterProtocolos.setValidado(Constantes.INFORME_ACTIVO);

		if (idDireccion != null) {
			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(idDireccion);
			filterProtocolos.setDireccion(direccion);
		}

		return this.protocolosService.findAll(filterProtocolos, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param protocolos
	 *            Protocolos Bean que contiene la informacion a modificar.
	 * @return Protocolos Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Protocolos edit(@RequestBody Protocolos protocolos,
			@ModelAttribute("usuario") Usuario usuario) {

		Date fechaHoy = new Date();

		protocolos.setFechaUltmodificacion(fechaHoy);
		protocolos.setUsuarioUltmodificacion(usuario.getUsuario());

		Protocolos protocolosAux = this.protocolosService.update(protocolos);
		ProtocolosController.logger.info("[PUT] : Protocolos actualizado correctamente");
		return protocolosAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param protocolos
	 *            Protocolos Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Protocolos Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Protocolos add(@RequestBody Protocolos protocolos,
			@ModelAttribute("usuario") Usuario usuario) {

		Date fechaHoy = new Date();

		protocolos.setFechaRegistro(fechaHoy);
		protocolos.setUsuarioRegistro(usuario.getUsuario());

		Protocolos protocolosAux = this.protocolosService.add(protocolos);
		ProtocolosController.logger.info("[POST] : Protocolos insertado correctamente");
		return protocolosAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idProtocolo
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return Protocolos Bean eliminado.
	 */
	@RequestMapping(value = "/{idProtocolo}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Protocolos remove(@PathVariable Integer idProtocolo) {
		Protocolos protocolos = new Protocolos();
		protocolos.setIdProtocolo(idProtocolo);
		this.preguntasProtocoloService.borrarRelProPreByProtocolo(protocolos);
		this.protocolosService.remove(protocolos);
		ProtocolosController.logger.info("[DELETE] : Protocolos borrado correctamente");
		return protocolos;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		ProtocolosController.logger.info("[GET - View] : protocolos");
		return "protocolos";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterProtocolos
	 *            Protocolos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Protocolos> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Protocolos> filter(
			@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - filter] : Obtener Protocolos");
		return this.protocolosService.filter(filterProtocolos, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterProtocolos
	 *            Protocolos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchProtocolos
	 *            Protocolos Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la bÃºsqueda.
	 * @return TableRowDto<Protocolos> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Protocolos>> search(
			@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody(param = "search") Protocolos searchProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - search] : Buscar Protocoloss");
		return this.protocolosService.search(filterProtocolos, searchProtocolos, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterProtocolos
	 *            Protocolos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Protocoloss");
		this.protocolosService.removeMultiple(filterProtocolos, tableRequestDto, false);
		ProtocolosController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterProtocolos
	 *            Protocolos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Protocolos>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Protocolos>> jerarquia(
			@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - jerarquia] : Obtener Protocoloss jerarquia");
		return this.protocolosService.jerarquia(filterProtocolos, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterProtocolos
	 *            Protocolos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Protocolos>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Protocolos>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - jerarquia] : Obtener Protocoloss jerarquia - Hijos");
		return this.protocolosService.jerarquiaChildren(filterProtocolos, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */

	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Protocolos> getClipboardReport(
			@RequestJsonBody(param = "filter") Protocolos filterProtocolos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProtocolosController.logger.info("[POST - clipboardReport] : : Copiar multiples usuarios");
		return this.protocolosService.getMultiple(filterProtocolos, tableRequestDto, false);
	}

	/**
	 * Método que genera una hoja de excel con los resultados de búsqueda de
	 * protocolos.
	 */
	@RequestMapping(value = "/exportarExcel/{sidx}/{sord}", method = RequestMethod.POST)
	public void getExcel(@ModelAttribute Protocolos filterProtocolos, @PathVariable String sidx,
			@PathVariable String sord, @ModelAttribute TableRequestDto tableRequestDto, HttpServletResponse response) {

		List<Protocolos> listaProtocolos = new ArrayList<Protocolos>();
		tableRequestDto.setSidx(sidx);
		tableRequestDto.setSord(sord);

		try {
			listaProtocolos = this.protocolosService.findAllLike(filterProtocolos, tableRequestDto, false);
			for (Protocolos protocolo : listaProtocolos) {
				protocolo.setNumeroPreguntas(this.protocolosService.calcularNumPreguntasProtocolo(protocolo));

				int numeroRespuestasProtocolo = this.protocolosService.calcularNumeroRespuestasProtocolo(protocolo);
				int numeroRespuestasValidar = this.protocolosService.calcularNumeroRespuestasValidar(protocolo);
				int numeroRespuestasTotal = numeroRespuestasProtocolo + numeroRespuestasValidar;

				protocolo.setNumeroRespuestas(numeroRespuestasTotal);
			}

			this.protocolosService.getExcel(listaProtocolos, response);

		} catch (Exception e) {
			ProtocolosController.logger.error(e.getMessage());
		}

	}

	/**
	 * Crea un diseño de informe técnico a partir de uno seleccionado y agrega
	 * las preguntas a la relación
	 * 
	 * @param protocolo
	 * @param usuario
	 * @return
	 */
	@RequestMapping(value = "/copiarInforme", method = RequestMethod.POST)
	public @ResponseBody Protocolos copiarInforme(@RequestBody Protocolos protocolo,
			@ModelAttribute("usuario") Usuario usuario) {

		int idProtocoloACopiar = protocolo.getIdProtocolo();
		Date fechaHoy = new Date();

		protocolo.setFechaRegistro(fechaHoy);
		protocolo.setUsuarioRegistro(usuario.getUsuario());
		protocolo.setFechaUltmodificacion(null);
		protocolo.setUsuarioUltmodificacion(null);

		// Creamos la copia
		Protocolos protocoloCopia = this.protocolosService.add(protocolo);

		PreguntasProtocolo preguntaProtocolo = new PreguntasProtocolo();
		preguntaProtocolo.setIdProtocolo(idProtocoloACopiar);

		// Buscamos las preguntas del protocolo a copiar
		List<PreguntasProtocolo> preguntasProtocolo = this.preguntasProtocoloService
				.getPreguntasRelProPre(preguntaProtocolo, null);

		for (PreguntasProtocolo pregunta : preguntasProtocolo) {
			RelProPre relProPre = new RelProPre();
			relProPre.setIdProtocolo(protocoloCopia.getIdProtocolo());
			relProPre.setIdPreguntaProtocolo(pregunta.getIdPreguntaProtocolo());
			relProPre.setIdPreguntaProtocoloPadre(pregunta.getIdPreguntaPadre());
			relProPre.setOrden(pregunta.getOrden());
			relProPre.setFechaRegistro(fechaHoy);
			relProPre.setUsuarioRegistro(usuario.getUsuario());

			// Creamos la relación de las preguntas con el nuevo protocolo
			this.preguntasProtocoloService.insertRelProPre(relProPre);
		}

		return protocoloCopia;
	}

	/**
	 * Valida el informe técnico seleccionado
	 * 
	 * @param idProtocolo
	 * @param usuario
	 * @return
	 */
	@RequestMapping(value = "/validarInforme/{idProtocolo}", method = RequestMethod.POST)
	public @ResponseBody Protocolos validarInforme(@PathVariable Integer idProtocolo, @ModelAttribute Usuario usuario) {

		Protocolos protocolo = new Protocolos();
		protocolo.setIdProtocolo(idProtocolo);

		protocolo = this.protocolosService.validarInforme(protocolo);

		return protocolo;
	}

	@RequestMapping(value = "invalidarInforme/{idProtocolo}", method = RequestMethod.POST)
	public @ResponseBody Protocolos invalidarInforme(@PathVariable Integer idProtocolo,
			@ModelAttribute Usuario usuario) {

		Protocolos protocolo = new Protocolos();
		protocolo.setIdProtocolo(idProtocolo);

		protocolo = this.protocolosService.invalidarInforme(protocolo);

		return protocolo;
	}

}
